package com.robot.HomeCtrl;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;

import InternetDetect.ConnectionDetector;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class TCPcontrol extends Activity{
	
	private final String DEBUG_TAG = "Home Control Debug";
	private String showIP;
	private String showPort;
	
	private TextView mIPView = null;
	private TextView mPortView = null;
	private TextView mTextView = null;
	private TextView servermsg = null;
	
	private Button SW1;
	private Button SW2;
	private Button SW3;
	private Button SW4;
	private Button SW5;
	private Button SW6;
	private Button SW7;
	private Button SW8;
	private Button SW9;
	private Button SW10;
	private Button ALLOFF;
	
	private Socket socket = null;
	
	private String message;
	private long SW1_flag = 0;
	private long SW2_flag = 0;
	private long SW3_flag = 0;
	private long SW4_flag = 0;
	private long SW5_flag = 0;
	private long SW6_flag = 0;
	private long SW7_flag = 0;
	private long SW8_flag = 0;
	private long SW9_flag = 0;
	private long SW10_flag = 0;
	
	private Handler handler = new Handler();
	
    // flag for Internet connection status
    Boolean isInternetPresent = false;
 
    // Connection detector class
    ConnectionDetector cd;
	
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tcpip);
        
		mIPView = (TextView) findViewById(R.id.textIPView);
		mPortView = (TextView) findViewById(R.id.textPortView);
		mTextView = (TextView) findViewById(R.id.mtextView);
		servermsg = (TextView) findViewById(R.id.server_status);
		
		SW1 = (Button) findViewById(R.id.button1);
		SW2 = (Button) findViewById(R.id.button2);
		SW3 = (Button) findViewById(R.id.button3);
		SW4 = (Button) findViewById(R.id.button4);
		SW5 = (Button) findViewById(R.id.button5);
		SW6 = (Button) findViewById(R.id.button6);
		SW7 = (Button) findViewById(R.id.button8);
		SW8 = (Button) findViewById(R.id.button9);
		SW9 = (Button) findViewById(R.id.button10);
		SW10 = (Button) findViewById(R.id.button11);
		
		ALLOFF = (Button) findViewById(R.id.button7);
		
		showIP = getIntent().getStringExtra("sendIptext");
		showPort = getIntent().getStringExtra("sendPort");
		
		mIPView.setText(showIP);
		mPortView.setText(showPort);
		
		SW1.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

		        // creating connection detector class instance
		        cd = new ConnectionDetector(getApplicationContext());
		 
		        /**
		         * Check Internet status button click event
		         * */
		        
		        // get Internet status
		        isInternetPresent = cd.isConnectingToInternet();

		        // check for Internet status
		        if (isInternetPresent) {
		            // Internet Connection is Present
		            // make HTTP requests
		        	
							if(SW1_flag == 0){
								
								message = "$XPORT=ONL1*************************************************************************************************************";
		
							}
							else if(SW1_flag == 1){
								
								message = "$XPORT=OFL1*************************************************************************************************************";
		
							}
							else if(SW1_flag > 1){
								
								SW1_flag = 0;
								
								message = "$XPORT=ONL1*************************************************************************************************************";
		
							}
							
							SW1_flag++;
							
							
							
							try{
			        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
			        			PrintWriter out = new PrintWriter(new BufferedWriter(
			        			  new OutputStreamWriter(socket.getOutputStream())),true);
			        			
			        			out.println(message);
			        			
			                    Thread TCPrev = new Thread(new TCPrevThread());
			                    TCPrev.start();
			                    
			                    out.close();
			                    socket.close();
			                    
			        		}catch (Exception e){
			        			Log.e(DEBUG_TAG, e.toString());
			        		}

		        } else {
		            // Internet connection is not present
		            // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
		           
		        }
        		
			}
				
		});
		
		
		SW2.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
                	
    				if(SW2_flag == 0){
    					
    					message = "$XPORT=ONL2*************************************************************************************************************";

    				}
    				else if(SW2_flag == 1){
    					
    					message = "$XPORT=OFL2*************************************************************************************************************";

    				}
    				else if(SW2_flag > 1){
    					
    					SW2_flag = 0;
    					
    					message = "$XPORT=ONL2*************************************************************************************************************";

    				}
    				
    				SW2_flag++;
            		
    				try{
            			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
            			PrintWriter out = new PrintWriter(new BufferedWriter(
            			  new OutputStreamWriter(socket.getOutputStream())),true);
            			
            			out.println(message);
            			
                        Thread TCPrev = new Thread(new TCPrevThread());
                        TCPrev.start();
                        
                        out.close();
                        socket.close();
                        
            		}catch (Exception e){
            			Log.e(DEBUG_TAG, e.toString());
            		}
                	
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
	        }
		});
		
		
		SW3.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
                	
					if(SW3_flag == 0){
						
						message = "$XPORT=ONL3*************************************************************************************************************";
	
					}
					else if(SW3_flag == 1){
						
						message = "$XPORT=OFL3*************************************************************************************************************";
	
					}
					else if(SW3_flag > 1){
						
						SW3_flag = 0;
						
						message = "$XPORT=ONL3*************************************************************************************************************";
	
					}
					SW3_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});
		
		
		SW4.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
                	
					if(SW4_flag == 0){
						
						message = "$XPORT=ONL4*************************************************************************************************************";
	
					}
					else if(SW4_flag == 1){
						
						message = "$XPORT=OFL4*************************************************************************************************************";
	
					}
					else if(SW4_flag > 1){
						
						SW4_flag = 0;
						
						message = "$XPORT=ONL4*************************************************************************************************************";
	
					}
					SW4_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});
		
		
		SW5.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
					if(SW5_flag == 0){
						
						message = "$XPORT=ONL5*************************************************************************************************************";
	
					}
					else if(SW5_flag == 1){
						
						message = "$XPORT=OFL5*************************************************************************************************************";
	
					}
					else if(SW5_flag > 1){
						
						SW5_flag = 0;
						
						message = "$XPORT=ONL5*************************************************************************************************************";
	
					}
					SW5_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});
		
		
		SW6.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
					if(SW6_flag == 0){
						
						message = "$XPORT=ONL6*************************************************************************************************************";
	
					}
					else if(SW6_flag == 1){
						
						message = "$XPORT=OFL6*************************************************************************************************************";
	
					}
					else if(SW6_flag > 1){
						
						SW6_flag = 0;
						
						message = "$XPORT=ONL6*************************************************************************************************************";
	
					}
					SW6_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});
		
		SW7.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
					if(SW7_flag == 0){
						
						message = "$XPORT=ONL7*************************************************************************************************************";
	
					}
					else if(SW7_flag == 1){
						
						message = "$XPORT=OFL7*************************************************************************************************************";
	
					}
					else if(SW7_flag > 1){
						
						SW7_flag = 0;
						
						message = "$XPORT=ONL7*************************************************************************************************************";
	
					}
					SW7_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});
		
		SW8.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
					if(SW8_flag == 0){
						
						message = "$XPORT=ONL8*************************************************************************************************************";
	
					}
					else if(SW8_flag == 1){
						
						message = "$XPORT=OFL8*************************************************************************************************************";
	
					}
					else if(SW8_flag > 1){
						
						SW8_flag = 0;
						
						message = "$XPORT=ONL8*************************************************************************************************************";
	
					}
					SW8_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});

		SW9.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
					if(SW9_flag == 0){
						
						message = "$XPORT=ONL9*************************************************************************************************************";
	
					}
					else if(SW9_flag == 1){
						
						message = "$XPORT=OFL9*************************************************************************************************************";
	
					}
					else if(SW9_flag > 1){
						
						SW9_flag = 0;
						
						message = "$XPORT=ONL9*************************************************************************************************************";
	
					}
					SW9_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});

		
		SW10.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
					if(SW10_flag == 0){
						
						message = "$XPORT=ONLA*************************************************************************************************************";
	
					}
					else if(SW10_flag == 1){
						
						message = "$XPORT=OFLA*************************************************************************************************************";
	
					}
					else if(SW10_flag > 1){
						
						SW10_flag = 0;
						
						message = "$XPORT=ONLA*************************************************************************************************************";
	
					}
					SW10_flag++;
					
	        		//TCPrecieve(); 
					
					try{
	        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
	        			PrintWriter out = new PrintWriter(new BufferedWriter(
	        			  new OutputStreamWriter(socket.getOutputStream())),true);
	        			
	        			out.println(message);
	        			
	                    Thread TCPrev = new Thread(new TCPrevThread());
	                    TCPrev.start();
	                    
	                    out.close();
	                    socket.close();
	                    
	        		}catch (Exception e){
	        			Log.e(DEBUG_TAG, e.toString());
	        		}
	        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
                
			}
		});



		
		ALLOFF.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
				
						SW1_flag = 0;
						SW2_flag = 0;
						SW3_flag = 0;
						SW4_flag = 0;
						SW5_flag = 0;
						SW6_flag = 0;
						SW7_flag = 0;
						SW8_flag = 0;
						SW9_flag = 0;
						SW10_flag = 0;
						
						message = "$XPORTOFFALL************************************************************************************************************";
					
						try{
		        			socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
		        			PrintWriter out = new PrintWriter(new BufferedWriter(
		        			  new OutputStreamWriter(socket.getOutputStream())),true);
		        			
		        			out.println(message);
		        			
		                    Thread TCPrev = new Thread(new TCPrevThread());
		                    TCPrev.start();
		                    
		                    out.close();
		                    socket.close();
		                    
		        		}catch (Exception e){
		        			Log.e(DEBUG_TAG, e.toString());
		        		}
		        		
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
		            showAlertDialog(TCPcontrol.this, "!!! No Internet Connection",
		                    "กรุณาเชื่อมต่อ Internet.", false);
                }
				
			}
		});
		
		
    } // End On Create
    
    /**
     * Function to display simple Alert Dialog
     * @param context - application context
     * @param title - alert dialog title
     * @param message - alert message
     * @param status - success/failure (used to set icon)
     * */
    public void showAlertDialog(Context context, String title, String message, Boolean status) {
        AlertDialog alertDialog = new AlertDialog.Builder(context).create();
 
        // Setting Dialog Title
        alertDialog.setTitle(title);
 
        // Setting Dialog Message
        alertDialog.setMessage(message);
 
        // Setting alert dialog icon
        //alertDialog.setIcon((status) ? R.drawable.success : R.drawable.fail);
 
        // Setting OK Button
        alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
        });
 
        // Showing Alert Message
        alertDialog.show();
    }

    
	public class TCPrevThread implements Runnable {
		
		public void run(){
			
			try {
				//socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
				
    			BufferedReader br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    			
    			String msg;
    			
    			mTextView.setText(mTextView.getText() + "\n" + br.readLine());
    			
    			while((msg = br.readLine()) != null)
    			{
    				Log.d("Comming Msg: ", msg);
    				mTextView.setText(mTextView.getText() + "\n" + msg);
    				
        			// Do compare If Data coming in is correct data

    			}
    			
    			br.close();
    			
			} catch (IOException e) {
				// TODO Auto-generated catch block
	                handler.post(new Runnable() {
	                    @Override
	                    public void run() {
	                    	servermsg.setText("Server Status Responding...");
	                        
	                        if(SW1_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW1.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON1");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW1_flag == 0 || SW1_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW1.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF1");

	            					}
	            				});
	                        }
	                        
	                        if(SW2_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW2.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON2");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW2_flag == 0 || SW2_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW2.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF2");

	            					}
	            				});
	                        }
	                        
	                        if(SW3_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW3.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW3_flag == 0 || SW3_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW3.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        
	                        if(SW4_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW4.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW4_flag == 0 || SW4_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW4.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        
	                        if(SW5_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW5.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW5_flag == 0 || SW5_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW5.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        
	                        //=============================================================
	                        if(SW6_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW6.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW6_flag == 0 || SW6_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW6.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        //============================================================
	                        //=============================================================
	                        if(SW7_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW7.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW7_flag == 0 || SW7_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW7.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        //============================================================
	                        //=============================================================
	                        if(SW8_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW8.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW8_flag == 0 || SW8_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW8.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        //============================================================
	                        //=============================================================
	                        if(SW9_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW9.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW9_flag == 0 || SW9_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW9.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        //============================================================
	                        //=============================================================
	                        if(SW10_flag == 1){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW10.setBackgroundResource(R.drawable.ggreenbutton);
	            						//mTextView.setText("ON3");

	            					}
	            				});
	    						
	                        }
	                        
	                        
	                        else if(SW10_flag == 0 || SW10_flag == 2){
	                        	
	    						handler.post(new Runnable(){
	    	        				
	            					public void run(){
	            					
	            						SW10.setBackgroundResource(R.drawable.gredbutton);
	            						//mTextView.setText("OFF3");

	            					}
	            				});
	                        }
	                        //============================================================
	                        
	                    }
	                });
				e.printStackTrace();
			}
		}
	}
}
